<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class AjustaSaldoMensalConsumidor {
    
    protected $entityManager;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
    
    public function ajustar ($conditions){
        try{
            $this->entityManager->beginTransaction();
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'INICIALIZA_SALDO_CONSUMIDOR');
            $procedure->addParam(new Param('P_CDFILIAL'  , Param::PARAM_INPUT , $conditions['CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCLIENTE'  , Param::PARAM_INPUT , $conditions['CDCLIENTE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DATA'  , Param::PARAM_INPUT , $conditions['DATA'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDOPERADOR'  , Param::PARAM_INPUT , $conditions['CDOPERADOR'], Param::PARAM_TYPE_STR));
            $procedure->execute();
            $this->entityManager->commit();
            return true;
        }catch (\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
}