<?php
namespace Teknisa\MAN\Utilities;

use Teknisa\MAN\Utilities\Jenkins;

class Jobs extends Jenkins
{	
    const TYPE_JOB_FREE_STYLE = 'hudson.model.FreeStyleProject';
    const TYPE_JOB_MAVEN = 'hudson.maven.MavenModuleSet';
    const TYPE_JOB_MULT_CONF = 'hudson.matrix.MatrixProject';
    const TYPE_JOB_EXTERNAL = 'hudson.model.ExternalJob';
    const TYPE_JOB_COPY = 'copy';

    public function createJob() {
        try {
            if($this->getSubmit() === null)
                $this->setSubmit('OK');

            $fieldsRequest = array(
                'name' => array($this->getName()),
                'mode' => array($this->getType()),
                'from' => array($this->getFrom()),
                'json' => array('{
                            "name": "' . $this->getName() . '",
                            "mode": "' . $this->getType() . '",
                            "from": "' . $this->getFrom() . '",
                            "Submit": "' . $this->getSubmit() . '"
                          }'),
                'Submit' => array($this->getSubmit())
            );

            $urlEncoded = self::encodeUrl($fieldsRequest);
            
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $this->getUrlCreateItem());
            curl_setopt($curl, CURLOPT_POST, true);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $urlEncoded);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
            curl_setopt($curl, CURLOPT_USERPWD, '2lu:11ea1ada0b53384f431f63f2c0b3b2c801'); // user:token
            
            // adicionando header por causa do NGROK (retirar depois)
            $headers = [
                'ngrok-skip-browser-warning: 1234'
            ];
            
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            
            curl_exec($curl);
            curl_close($curl);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function configuration() {
        try {
			self::validateFieldsRequiredCreate();
			 
            if($this->getSubmit() === null)
                $this->setSubmit('Salvar');

            self::showMessageFiedsRequired(array('Name' => $this->getName()));

            $fieldsRequest = array(
                'name'        => array($this->getName()),
                'description' => array($this->getDescription()),
                /*                '_.daysToKeepStr' => array(''),
                //                '_.numToKeepStr' => array(''),
                //                '_.artifactDaysToKeepStr' => array(''),
                //                '_.artifactNumToKeepStr' => array(''),
                //                'stapler-class' => array('hudson.tasks.LogRotator',
                //                    'hudson.scm.CvsRepositoryLocation$BranchRepositoryLocation',
                //                    'hudson.scm.CvsRepositoryLocation$HeadRepositoryLocation',
                //                    'hudson.scm.CvsRepositoryLocation$TagRepositoryLocation',
                //                    'hudson.scm.browsers.FishEyeCVS',
                //                    'hudson.scm.browsers.OpenGrok',
                //                    'hudson.scm.browsers.ViewCVS',
                //                    'hudson.scm.CvsRepositoryLocation$BranchRepositoryLocation',
                //                    'hudson.scm.CvsRepositoryLocation$HeadRepositoryLocation',
                //                    'hudson.scm.CvsRepositoryLocation$TagRepositoryLocation',
                //                    'hudson.scm.browsers.FishEyeCVS',
                //                    'hudson.scm.browsers.OpenGrok',
                //                    'hudson.scm.browsers.ViewCVS',
                //                    'hudson.scm.browsers.CvsFacadeRepositoryBrowser',
                //                    'hudson.scm.browsers.FishEyeCVS',
                //                    'hudson.scm.browsers.OpenGrok',
                //                    'hudson.scm.browsers.ViewCVS',
                //                    'hudson.scm.subversion.UpdateUpdater',
                //                    'hudson.scm.subversion.CheckoutUpdater',
                //                    'hudson.scm.subversion.UpdateWithCleanUpdater',
                //                    'hudson.scm.subversion.UpdateWithRevertUpdater',
                //                    'hudson.scm.browsers.Assembla',
                //                    'hudson.scm.browsers.CollabNetSVN',
                //                    'hudson.scm.browsers.FishEyeSVN',
                //                    'hudson.scm.browsers.SVNWeb',
                //                    'hudson.scm.browsers.Sventon',
                //                    'hudson.scm.browsers.Sventon2',
                //                    'hudson.scm.browsers.ViewSVN',
                //                    'hudson.scm.browsers.WebSVN',
                //                    'hudson.tasks.BatchFile'
                //                ),
                //                '$class' => array('hudson.tasks.LogRotator',
                //                    'hudson.scm.CvsRepositoryLocation$BranchRepositoryLocation',
                //                    'hudson.scm.CvsRepositoryLocation$HeadRepositoryLocation',
                //                    'hudson.scm.CvsRepositoryLocation$TagRepositoryLocation',
                //                    'hudson.scm.browsers.FishEyeCVS',
                //                    'hudson.scm.browsers.OpenGrok',
                //                    'hudson.scm.browsers.ViewCVS',
                //                    'hudson.scm.CvsRepositoryLocation$BranchRepositoryLocation',
                //                    'hudson.scm.CvsRepositoryLocation$HeadRepositoryLocation',
                //                    'hudson.scm.CvsRepositoryLocation$TagRepositoryLocation',
                //                    'hudson.scm.browsers.FishEyeCVS',
                //                    'hudson.scm.browsers.OpenGrok',
                //                    'hudson.scm.browsers.ViewCVS',
                //                    'hudson.scm.browsers.CvsFacadeRepositoryBrowser',
                //                    'hudson.scm.browsers.FishEyeCVS',
                //                    'hudson.scm.browsers.OpenGrok',
                //                    'hudson.scm.browsers.ViewCVS',
                //                    'hudson.scm.subversion.UpdateUpdater',
                //                    'hudson.scm.subversion.CheckoutUpdater',
                //                    'hudson.scm.subversion.UpdateWithCleanUpdater',
                //                    'hudson.scm.subversion.UpdateWithRevertUpdater',
                //                    'hudson.scm.browsers.Assembla',
                //                    'hudson.scm.browsers.CollabNetSVN',
                //                    'hudson.scm.browsers.FishEyeSVN',
                //                    'hudson.scm.browsers.SVNWeb',
                //                    'hudson.scm.browsers.Sventon',
                //                    'hudson.scm.browsers.Sventon2',
                //                    'hudson.scm.browsers.ViewSVN',
                //                    'hudson.scm.browsers.WebSVN',
                //                    'hudson.tasks.BatchFile'
                //                ),
                //            'stapler-class-bag' => array('true'),
                //            'quiet_period' => array('5'),
                //            'scmCheckoutRetryCount' => array('0'),
                //            'customWorkspace.directory' => array(''),
                //                'childCustomWorkspace.directory' => array(''),
                //                '_.displayNameOrNull' => array(''),
                //                'scm' => array('0'),
                //                '_.cvsRoot' => array('', ''),
                //                '_.password' => array('', '', ''),
                //                '_.branchName' => array('', ''),
                //                '_.tagName' => array('', ''),
                //                '_.remoteName' => array('', ''),
                //                '_.localName' => array('', ''),
                //                '_.pattern' => array('', ''),
                //                '_.compressionLevel' => array('-1', '-1'),
                //                '_.canUseUpdate' => array('on', 'on'),
                //                '_.pruneEmptyDirectories' => array('on', 'on'),
                //                '_.projectsetFileName' => array(''),
                //                '_.username' => array(''),
                //                '_.remote' => array(''),
                //                '_.local' => array('.'),
                //                'depthOption' => array('infinity'),
                //                '_.excludedRegions' => array(''),
                //                '_.includedRegions' => array(''),
                //                '_.excludedUsers' => array(''),
                //                '_.excludedCommitMessages' => array(''),
                //                '_.excludedRevprop' => array(''),
                //                '_.upstreamProjects' => array(''),
                //                'scmpoll_spec' => array(''),
                //                'combinationFilter' => array(''),
                //                '_.touchStoneCombinationFilter' => array(''),*/
                'ReverseBuildTrigger.threshold' => array('SUCCESS'),
                'hudson-triggers-TimerTrigger'  => array('on'),
                '_.spec'                        => array($this->getPeriod()),
                'touchStoneResultCondition'     => array('SUCCESS'),
                'command'                       => array($this->getMethod()),
                'core:apply'                    => array(''),
                'json' => array('{"name": "' . $this->getName() . '",
                            "description": "' . $this->getDescription() . '",
                            "logrotate": true,
                            "": "0",
                            "buildDiscarder":
                                {"daysToKeepStr": "1",
                                 "numToKeepStr": "1",
                                 "artifactDaysToKeepStr": "",
                                 "artifactNumToKeepStr": "",
                                 "stapler-class": "hudson.tasks.LogRotator",
                                 "$class": "hudson.tasks.LogRotator"
                                },
                            "properties":
                                {"stapler-class-bag": "true",
                                 "hudson-model-ParametersDefinitionProperty": {}
                                },
                            "disable": false,
                            "concurrentBuild": false,
                            "hasCustomQuietPeriod": false,
                            "quiet_period": "5",
                            "hasCustomScmCheckoutRetryCount": false,
                            "scmCheckoutRetryCount": "0",
                            "blockBuildWhenUpstreamBuilding": false,
                            "blockBuildWhenDownstreamBuilding": false,
                            "displayNameOrNull": "",
                            "scm": {"value": "0"},
                            "hudson-triggers-TimerTrigger": {"spec": "' . $this->getPeriod() . '"},
                            "executionStrategy":
                                {"runSequentially": false,
                                 "hasTouchStoneCombinationFilter": false,
                                 "touchStoneCombinationFilter": "",
                                 "touchStoneResultCondition": "SUCCESS"
                                },
                            "builder":
                                {"command": "' . addslashes($this->getMethod()) . '",
                                 "stapler-class": "hudson.tasks.Shell",
                                 "$class": "hudson.tasks.Shell"
                                },
                            "core:apply": ""}'
                ),
                'Submit' => array($this->getSubmit())
            );
            
            $encodedUrl = self::encodeUrl($fieldsRequest);

            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $this->getUrlConfig());
            curl_setopt($curl, CURLOPT_POST, true);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $encodedUrl);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
            curl_setopt($curl, CURLOPT_USERPWD, '2lu:11ea1ada0b53384f431f63f2c0b3b2c801'); // user:token

            // adicionando header por causa do NGROK (retirar depois)
            $headers = [
                'ngrok-skip-browser-warning: 1234'
            ];
                
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        
            curl_exec($curl);
            curl_close($curl);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function deleteJob() {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $this->getUrlDelete());
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
        curl_setopt($curl, CURLOPT_USERPWD, '2lu:11ea1ada0b53384f431f63f2c0b3b2c801'); // user:token
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
        
        // adicionando header por causa do NGROK (retirar depois)
        $headers = [
            'ngrok-skip-browser-warning: 1234'
        ];
            
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    
        curl_exec($curl);
        curl_close($curl);
    }

    public static function encodeUrl($fieldsRequest) {
        $urlEncoded = null;
        
        foreach($fieldsRequest as $key => $fields) {
            $key = urlencode(trim($key));
            foreach($fields as $value) {
                $value = urlencode(trim($value));
                $urlEncoded .= $key . '=' . $value . '&';
            }
        }
        
        if(!empty($urlEncoded))
            $urlEncoded = rtrim($urlEncoded, '&');

        return $urlEncoded;
    }

    public static function revertDirectory($directory) {
        return str_replace('\\', '/', $directory);
    }

    public function validateFieldsRequiredCreate() {
        $fieldsRequired = array(
            'Url Jenkins'     => $this->getUrlJenkins(),
            'Url Create Item' => $this->getUrlCreateItem(),
            'Name'            => $this->getName(),
            'Type'            => $this->getType(),
        );

        self::showMessageFiedsRequired($fieldsRequired);

        if($fieldsRequired['Type'] == self::TYPE_JOB_COPY && $this->getFrom() == null)
            throw new \Exception('From is required.');
        elseif($fieldsRequired['Type'] != self::TYPE_JOB_COPY)
            $this->setFrom(null);
    }

    public static function showMessageFiedsRequired($fieldsRequired) {
        foreach($fieldsRequired as $key => $field) {
            if(empty($field))
                throw new \Exception($key . ' is required.');
        }
    }

    public static function formatDateToExecute($dateExec, $dayWeek = '*') {
        $dateExec = trim($dateExec);
		
        list($hour, $min, $day, $month) = array('*', '*', '*', '*');
        
		if(!empty($dateExec) && strlen($dateExec) > 10) {
            list($date, $time) = explode(" ", $dateExec);
            list($day, $month) = explode("/", $date);
            list($hour, $min) = explode(":", $time);
        } elseif(strlen($dateExec) == 10)
            list($day, $month) = explode("/", $dateExec);
			
        $dateExec = implode(" ", array($min, $hour, $day, $month, $dayWeek));
        return $dateExec;
    }
}
